<?php

require_once 'base/GepTiposolicitacaoEntityBase.php';

/**
 * GepTipoSolicitacaoEntity.
 *
 * @package Entity
 * @author  daniellepereira <username@example.com>
 */
class GepTiposolicitacaoEntity extends GepTiposolicitacaoEntityBase
{


    const SEM_TIPOSOLICITACAO = 0;


    /**
    * Gera o novo c?digo de Tipo de Solicitacao por Tipo de Fluxo.
    *
    * @param integer $nrorg N?mero da Organiza??o.
    *
    * @return integer
    */
    public static function retornaProxNumeroTipoSolicitacao($nrorg) {
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_TIPOSOLICITACAO', 10);
        return $codigo;
    }


    /**
     * Retorna dados de um tipo de solicita??o.
     *
     * @param integer $nrorg    N?mero da Organiza??o.
     * @param integer $tp_fluxo N?mero do tipo de fluxo.
     *
     * @return boolean
     */
    public function retornaConsultaTipoSoliFluxo($nrorg, $tp_fluxo) {
        $situacao = GepTiposolicitacao::consultaTipoSolicitacaoFluxo($nrorg, $tp_fluxo);

        if ($situacao instanceof GepTiposolicitacaoEntity) {
            return $situacao;
        }

        throw new Exception('GepTiposolicitacaoEntity: Nao ha situacao inicial para este tipo de fluxo!');
    }


    /**         ok
     * Retorna dados de um tp de solicitacao.
     *
     * @param integer $nrorg    Numero da Organizacao.
     * @param integer $tp_fluxo Tipo do fluxo.
     * @param integer $tp_soli  Tipo da solicitacao.
     *
     * @throws Exception Caso nao tenha registro.
     *
     * @return GepTiposolicitacaoEntity
     */
    public function retornaConsultaTipoSoli($nrorg, $tp_fluxo, $tp_soli){
        $situacao = GepTiposolicitacao::consultaTipoSolicitacao($nrorg, $tp_fluxo, $tp_soli);

        if ($situacao instanceof GepTiposolicitacaoEntity) {
            return $situacao;
        }

        throw new Exception(
            'GepTiposolicitacaoEntity: Nao ha situacao inicial para este tipo de solicitacao!',
            self::SEM_TIPOSOLICITACAO
        );
    }


    /**       ok
     * Retorna quantidade de tipos de solicitacao em determinado tipo de fluxo.
     *
     * @param integer $nrorg       Nao da Organizacao.
     * @param integer $nrtipofluxo Tipo de fluxo.
     *
     * @throws Exception           Sem registro de consulta.
     * @return Ambigous <Ambigous, boolean, NULL, TkModelEntity>
     */
    public static function retornaTipoSolicitacao($nrorg, $nrtipofluxo){
        $consulta = GepTiposolicitacao::consultaListaTipoSolicitacao(
            $nrorg,
            $nrtipofluxo
        );
        if (count($consulta[0])>0) {
            return $consulta;
        }

        throw new Exception(
            'GepTiposolicitacaoEntity: Nao ha tipo de solicitacao para este tipo de fluxo!',
            GepTiposolicitacaoEntity::SEM_TIPOSOLICITACAO
        );
    }


}